TagLib::MP4::File Class Reference

An implementation of TagLib::File with MP4 specific methods. More...

`#include <mp4file.h>`

Inheritance diagram for TagLib::MP4::File:
[legend]
Collaboration diagram for TagLib::MP4::File:
[legend]

## Public Types

enum | TagTypes { NoTags = 0x0000 , MP4 = 0x0001 , AllTags = 0xffff }
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }

## Public Member Functions

| File (FileName file, bool readProperties=true, Properties::ReadStyle audioPropertiesStyle=Properties::Average, ItemFactory *itemFactory=nullptr)
| File (IOStream *stream, bool readProperties=true, Properties::ReadStyle audioPropertiesStyle=Properties::Average, ItemFactory *itemFactory=nullptr)
| ~File () override
| File (const File &)=delete
File & | operator= (const File &)=delete
Tag * | tag () const override
PropertyMap | properties () const override
void | removeUnsupportedProperties (const StringList &properties) override
PropertyMap | setProperties (const PropertyMap &) override
Properties * | audioProperties () const override
bool | save () override
bool | strip (int tags=AllTags)
bool | hasMP4Tag () const
Public Member Functions inherited from TagLib::File
| File (const File &)=delete
File & | operator= (const File &)=delete
FileName | name () const
virtual StringList | complexPropertyKeys () const
virtual List< VariantMap > | complexProperties (const String &key) const
virtual bool | setComplexProperties (const String &key, const List< VariantMap > &value)
ByteVector | readBlock (size_t length)
void | writeBlock (const ByteVector &data)
offset_t | find (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
offset_t | rfind (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, offset_t start=0, size_t replace=0)
void | removeBlock (offset_t start=0, size_t length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (offset_t offset, Position p=Beginning)
void | clear ()
offset_t | tell () const
offset_t | length ()

## Static Public Member Functions

static bool | isSupported (IOStream *stream)

## Additional Inherited Members

Protected Member Functions inherited from TagLib::File
| File (FileName fileName)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (offset_t length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An implementation of TagLib::File with MP4 specific methods.

This implements and provides an interface for MP4 files to the TagLib::Tag and TagLib::AudioProperties interfaces by way of implementing the abstract TagLib::File API as well as providing some additional information specific to MP4 files.

## Member Enumeration Documentation

## TagTypes

enum TagLib::MP4::File::TagTypes

This set of flags is used for strip() and is suitable for being OR-ed together.

Enumerator
NoTags | Empty set. Matches no tag types.
MP4 | Matches MP4 tags.
AllTags | Matches all tag types.

## Constructor & Destructor Documentation

## File() [1/3]

TagLib::MP4::File::File | ( | FileName | file,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | audioPropertiesStyle = Properties::Average,
|  | ItemFactory * | itemFactory = nullptr )

Constructs an MP4 file from file. If readProperties is `true` the file's audio properties will also be read.

Note
  In the current implementation, propertiesStyle is ignored.

The items will be created using itemFactory (default if null).

References TagLib::AudioProperties::Average.

Referenced by File(), and operator=().

## File() [2/3]

TagLib::MP4::File::File | ( | IOStream * | stream,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | audioPropertiesStyle = Properties::Average,
|  | ItemFactory * | itemFactory = nullptr )

Constructs an MP4 file from stream. If readProperties is `true` the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.
  In the current implementation, propertiesStyle is ignored.

The items will be created using itemFactory (default if null).

References TagLib::AudioProperties::Average.

## ~File()

TagLib::MP4::File::~File | ( |  | ) |

override virtual

Destroys this instance of the File.

Reimplemented from TagLib::File.

## File() [3/3]

TagLib::MP4::File::File | ( | const File & |  | ) |

delete

References File().

## Member Function Documentation

## audioProperties()

Properties * TagLib::MP4::File::audioProperties | ( |  | ) | const

override virtual

Returns the MP4 audio properties for this file.

Implements TagLib::File.

## hasMP4Tag()

bool TagLib::MP4::File::hasMP4Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an MP4 tag, or the file has a Metadata Item List (ilst) atom.

## isSupported()

bool TagLib::MP4::File::isSupported | ( | IOStream * | stream | ) |

static

Returns whether or not the given stream can be opened as an ASF file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

References TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## operator=()

File & TagLib::MP4::File::operator= | ( | const File & |  | ) |

delete

References File().

## properties()

PropertyMap TagLib::MP4::File::properties | ( |  | ) | const

override virtual

Implements the unified property interface – export function.

Reimplemented from TagLib::File.

Referenced by removeUnsupportedProperties().

## removeUnsupportedProperties()

void TagLib::MP4::File::removeUnsupportedProperties | ( | const StringList & | properties | ) |

override virtual

Removes unsupported properties. Forwards to the actual Tag's removeUnsupportedProperties() function.

Reimplemented from TagLib::File.

References properties().

## save()

bool TagLib::MP4::File::save | ( |  | ) |

override virtual

Save the file.

This returns `true` if the save was successful.

Implements TagLib::File.

## setProperties()

PropertyMap TagLib::MP4::File::setProperties | ( | const PropertyMap & |  | ) |

override virtual

Implements the unified property interface – import function.

Reimplemented from TagLib::File.

## strip()

bool TagLib::MP4::File::strip | ( | int | tags = AllTags | ) |

This will strip the tags that match the OR-ed together TagTypes from the file. By default it strips all tags. It returns `true` if the tags are successfully stripped.

Note
  This will update the file immediately.

References AllTags.

## tag()

Tag * TagLib::MP4::File::tag | ( |  | ) | const

override virtual

Returns a pointer to the MP4 tag of the file.

MP4::Tag implements the tag interface, so this serves as the reimplementation of TagLib::File::tag().

Note
  The Tag is still owned by the MP4::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

Implements TagLib::File.

The documentation for this class was generated from the following file:

- mp4file.h